2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
22 prefix=$(git rev-parse --show-prefix) || exit 1
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
31 if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files "$@")")
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
55 git ls-files -o $z $excl_opt -- "$@"
58 prepare_fallback_ident () {
59 if ! git -c user.useconfigonly=yes var GIT_COMMITTER_IDENT >/dev/null 2>&1
61 GIT_AUTHOR_NAME="git stash"
62 GIT_AUTHOR_EMAIL=git@stash
63 GIT_COMMITTER_NAME="git stash"
64 GIT_COMMITTER_EMAIL=git@stash
65 export GIT_AUTHOR_NAME
66 export GIT_AUTHOR_EMAIL
67 export GIT_COMMITTER_NAME
68 export GIT_COMMITTER_EMAIL
75 die "$(gettext "git stash clear with parameters is unimplemented")"
77 if current=$(git rev-parse --verify --quiet $ref_stash)
79 git update-ref -d $ref_stash $current
85 prepare_fallback_ident
94 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
100 stash_msg=${1#--message=}
102 -u|--include-untracked)
104 untracked=${1?"BUG: create_stash () -u requires an argument"}
114 git update-index -q --refresh
120 # state of the base commit
121 if b_commit=$(git rev-parse --verify HEAD)
123 head=$(git rev-list --oneline -n 1 HEAD --)
125 die "$(gettext "You do not have the initial commit yet")"
128 if branch=$(git symbolic-ref -q HEAD)
130 branch=${branch#refs/heads/}
134 msg=$(printf '%s: %s' "$branch" "$head")
137 i_tree=$(git write-tree) &&
138 i_commit=$(printf 'index on %s\n' "$msg" |
139 git commit-tree $i_tree -p $b_commit) ||
140 die "$(gettext "Cannot save the current index state")"
142 if test -n "$untracked"
144 # Untracked files are stored by themselves in a parentless commit, for
145 # ease of unpacking later.
147 untracked_files -z "$@" | (
148 GIT_INDEX_FILE="$TMPindex" &&
149 export GIT_INDEX_FILE &&
151 git update-index -z --add --remove --stdin &&
152 u_tree=$(git write-tree) &&
153 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
155 ) ) || die "$(gettext "Cannot save the untracked files")"
157 untracked_commit_option="-p $u_commit";
159 untracked_commit_option=
162 if test -z "$patch_mode"
165 # state of the working tree
167 git read-tree --index-output="$TMPindex" -m $i_tree &&
168 GIT_INDEX_FILE="$TMPindex" &&
169 export GIT_INDEX_FILE &&
170 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
171 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
175 die "$(gettext "Cannot save the current worktree state")"
179 rm -f "$TMP-index" &&
180 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
182 # find out what the user wants
183 GIT_INDEX_FILE="$TMP-index" \
184 git add--interactive --patch=stash -- "$@" &&
186 # state of the working tree
187 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
188 die "$(gettext "Cannot save the current worktree state")"
190 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
191 test -s "$TMP-patch" ||
192 die "$(gettext "No changes selected")"
194 rm -f "$TMP-index" ||
195 die "$(gettext "Cannot remove temporary index (can't happen)")"
200 if test -z "$stash_msg"
202 stash_msg=$(printf 'WIP on %s' "$msg")
204 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
206 w_commit=$(printf '%s\n' "$stash_msg" |
207 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
208 die "$(gettext "Cannot record working tree state")"
227 # only default to keep if we don't already have an override
228 test -z "$keep_index" && keep_index=t
233 -u|--include-untracked)
241 test -z ${1+x} && usage
248 stash_msg=${1#--message=}
259 eval_gettextln "error: unknown option for 'stash push': \$option"
269 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
271 if test -n "$patch_mode" && test -n "$untracked"
273 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
276 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
278 git update-index -q --refresh
281 say "$(gettext "No local changes to save")"
285 git reflog exists $ref_stash ||
286 clear_stash || die "$(gettext "Cannot initialize stash")"
288 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
289 git stash--helper store -m "$stash_msg" -q $w_commit ||
290 die "$(gettext "Cannot save the current status")"
291 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
293 if test -z "$patch_mode"
295 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
296 if test -n "$untracked" && test $# = 0
298 git clean --force --quiet -d $CLEAN_X_OPTION
303 test -z "$untracked" && UPDATE_OPTION="-u" || UPDATE_OPTION=
304 test "$untracked" = "all" && FORCE_OPTION="--force" || FORCE_OPTION=
305 git add $UPDATE_OPTION $FORCE_OPTION -- "$@"
306 git diff-index -p --cached --binary HEAD -- "$@" |
312 if test "$keep_index" = "t" && test -n "$i_tree"
314 git read-tree --reset $i_tree
315 git ls-files -z --modified -- "$@" |
316 git checkout-index -z --force --stdin
319 git apply -R < "$TMP-patch" ||
320 die "$(gettext "Cannot remove worktree changes")"
322 if test "$keep_index" != "t"
339 # pass all options through to push_stash
340 push_options="$push_options $1"
351 if test -z "$stash_msg"
353 push_stash $push_options
355 push_stash $push_options -m "$stash_msg"
365 # Parses the remaining options looking for flags and
366 # at most one revision defaulting to ${ref_stash}@{0}
369 # Derives related tree and commit objects from the
370 # revision, if one is found.
372 # stash records the work tree, and is a merge between the
373 # base commit (first parent) and the index tree (second parent).
375 # REV is set to the symbolic version of the specified stash-like commit
376 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
377 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
378 # s is set to the SHA1 of the stash commit
379 # w_commit is set to the commit containing the working tree
380 # b_commit is set to the base commit
381 # i_commit is set to the commit containing the index tree
382 # u_commit is set to the commit containing the untracked files tree
383 # w_tree is set to the working tree
384 # b_tree is set to the base tree
385 # i_tree is set to the index tree
386 # u_tree is set to the untracked files tree
388 # GIT_QUIET is set to t if -q is specified
389 # INDEX_OPTION is set to --index if --index is specified.
390 # FLAGS is set to the remaining flags (if allowed)
393 # * too many revisions specified
394 # * no revision is specified and there is no stash stack
395 # * a revision is specified which cannot be resolve to a SHA1
396 # * a non-existent stash reference is specified
397 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
400 test "$1" = "-p" && set "push" "$@"
402 PARSE_CACHE='--not-parsed'
403 # The default command is "push" if nothing but options are given
410 *) seen_non_option=t; break ;;
414 test -n "$seen_non_option" || set "push" "$@"
420 git stash--helper list "$@"
424 git stash--helper show "$@"
433 git stash--helper push "$@"
438 git stash--helper apply "$@"
442 git stash--helper clear "$@"
446 git stash--helper create --message "$*"
450 git stash--helper store "$@"
454 git stash--helper drop "$@"
459 git stash--helper pop "$@"
464 git stash--helper branch "$@"
470 git stash--helper push &&
471 say "$(gettext "(To restore them type \"git stash apply\")")"